<?php
/*	photo tiles plugin
	author: team1/3
*/

function photo_tiles_renderer(&$page_ar)
{
	global $html,$params,$database,$ut;

	if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_photo_tiles_add') {
		$r = array();
		$r['result'] = false;
		$r['src'] = sanitize_str($_POST['data'],false);
		if (empty($page_ar['meta']['plugin_photo_tiles']['img'])) {
			$page_ar['meta']['plugin_photo_tiles']['img'] = array();
		}
		$page_ar['meta']['plugin_photo_tiles']['img'][] = $r['src'];
		$r['result'] = mod_data_items($page_ar);
		echo( json_encode($r) );
		exit();
	}
	
	// default set
	if (empty($page_ar['meta']['plugin_photo_tiles']['writer'])) {
		$page_ar['meta']['plugin_photo_tiles']['writer'] = 'photo_tiles_writer';
	}
	if (empty($page_ar['meta']['plugin_photo_tiles']['height'])) {
		$page_ar['meta']['plugin_photo_tiles']['height'] = '100px';
	}
	if (empty($page_ar['meta']['plugin_photo_tiles']['width'])) {
		$page_ar['meta']['plugin_photo_tiles']['width'] = '100px';
	}
	if (empty($page_ar['meta']['plugin_photo_tiles']['gap'])) {
		$page_ar['meta']['plugin_photo_tiles']['gap'] = '10px';
	}

	if (check_rights('edit')) {
$html['meta']['photo_tiles_renderer'] = <<<EOT
		<script>
			\$(function() {
				ot.plugin_photo_tiles_add = function (id) {
					opt = {};
					opt.id = id;
					opt.title = 'Add Tile image';
					opt.select = function(obj){
						var u = \$(obj).attr('src');
						ot.ajax({
							type: "POST"
							, url: '{$_SERVER['REQUEST_URI']}'
							, data: "ajax=plugin_photo_tiles_add&data="+encodeURIComponent(u)
							, dataType:'json'
							, success: function(data){
								if ( data && data['result'] ) {
									location.reload(true);
								}
							}
						});
					}
					ot.open_uploader(opt);
				};
			})
		</script>
EOT;
	}

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","plugin_photo_tiles_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "plugin_photo_tiles_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $page_ar['id'];
			$r['meta']['plugin_photo_tiles'] = $page_ar['meta']['plugin_photo_tiles'];

$r['html'] = <<<EOT
			<table>
				<tr>
					<td >Writer</td>
					<td>
						{$ut->input(array(
							'type'=>'select'
							, 'data-input'=>'plugin_photo_tiles_writer'
							, 'value'=>$r['meta']['plugin_photo_tiles']['writer']
							, 'option'=>array('photo_tiles_writer'=>'photo_tiles_writer','photo_line_writer'=>'photo_line_writer')
						))}
					</td>
				</tr>
				<tr>
					<td >tile width</td>
					<td>
						<input type='text' data-input='plugin_photo_tiles_width' value='{$r['meta']['plugin_photo_tiles']['width']}' />
					</td>
				</tr>
				<tr>
					<td >tile height</td>
					<td>
						<input type='text' data-input='plugin_photo_tiles_height' value='{$r['meta']['plugin_photo_tiles']['height']}' />
					</td>
				</tr>
				<tr>
					<td >tile gap</td>
					<td>
						<input type='text' data-input='plugin_photo_tiles_gap' value='{$r['meta']['plugin_photo_tiles']['gap']}' />
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_plugin_photo_tiles_setting')  {

			$r = array();
			$r['id'] = $page_ar['id'];
			$r['meta']['plugin_photo_tiles'] = $page_ar['meta']['plugin_photo_tiles'];

			if (!empty($_POST['plugin_photo_tiles_writer'])) {
				$r['meta']['plugin_photo_tiles']['writer'] = sanitize_asc($_POST['plugin_photo_tiles_writer']);
			} else {
				unset($r['meta']['plugin_photo_tiles']['writer']);
			}
			if (!empty($_POST['plugin_photo_tiles_width'])) {
				$r['meta']['plugin_photo_tiles']['width'] = sanitize_asc($_POST['plugin_photo_tiles_width']);
			} else {
				unset($r['meta']['plugin_photo_tiles']['width']);
			}
			if (!empty($_POST['plugin_photo_tiles_height'])) {
				$r['meta']['plugin_photo_tiles']['height'] = sanitize_asc($_POST['plugin_photo_tiles_height']);
			} else {
				unset($r['meta']['plugin_photo_tiles']['height']);
			}
			if (!empty($_POST['plugin_photo_tiles_gap'])) {
				$r['meta']['plugin_photo_tiles']['gap'] = sanitize_asc($_POST['plugin_photo_tiles_gap']);
			} else {
				unset($r['meta']['plugin_photo_tiles']['gap']);
			}

			$r['metadata'] = serialize64($r['meta']);
			$r['result'] = mod_data_items($r);

			echo(json_encode($r));
			exit();
		}
	}
	
$buff = '';
	if (empty($page_ar['meta']['plugin_photo_tiles']['img'])) {
		$buff .= '<p>no image</p>';
	} else {
		$buff .= $page_ar['meta']['plugin_photo_tiles']['writer']($page_ar);
	}
	if (check_rights('edit')) {
$buff .= <<<EOT
		<div class="edit_pointer ">	
			<a href='javascript:void(ot.plugin_photo_tiles_add({$page_ar['id']}))' class='onethird-button mini'>Add Image</a>
			<a href='javascript:void(ot.plugin_photo_tiles_setting())' class='onethird-button mini'>Setting</a>
EOT;
			$buff .= std_blockmenu_renderer($page_ar);
$buff .= <<<EOT
		</div>
EOT;
	}
	
$buff .= <<<EOT
EOT;
	return frame_renderer($buff);
}

function photo_tiles_writer(&$page_ar) 
{
	global $html,$params,$database,$ut;

	$h = $page_ar['meta']['plugin_photo_tiles']['height'];
	$w = $page_ar['meta']['plugin_photo_tiles']['width'];
	$g = $page_ar['meta']['plugin_photo_tiles']['gap'];

$html['css']['photo_tiles_writer'] = <<<EOT
	<style>
	.photo_tiles_writer  {
		position: relative;
		margin:20px 0 10px 0;
	}
	.photo_tiles_writer .item {
		position: relative;
		display:inline-block;
		height:$h;
		width:$w;
		overflow: hidden;
	}
	.photo_tiles_writer .item > div{
		padding:0 $g $g 0;
		overflow: hidden;
	}
	.photo_tiles_writer .item > div img {
		width:100%
	}
	.photo_tiles_writer .item > div .txt {
		position: absolute;
		top: 0;
		right: $g;
		padding:2px 5px;
		display: inline-block;
		background-color: rgba(255, 255, 255, 0.56);
		font-weight: bold;
		font-size:12px;
    }
	</style>
EOT;

$html['meta']['photo_tiles_writer-resize'] = <<<EOT
	<script>
	\$(function(){
		ot.photo_tiles_onresize = function() {
			var obj = \$('.photo_tiles_writer');
			var w = obj.width();
			if (!ot.photo_tiles_width || ot.photo_tiles_width - 10 > w || ot.photo_tiles_width  + 10 < w) {
				ot.photo_tiles_width = w;
				var o = \$('.photo_tiles_writer .item');
				if (!ot.photo_tiles_item_width) {
					ot.photo_tiles_item_width = o.width() ;
				}
				a = parseInt(ot.photo_tiles_width /ot.photo_tiles_item_width);
				d = (100/a-0.01).toFixed(2);
				o.css('width',d+'%');
			}
		}
		\$(window).on('resize', function(){
			ot.photo_tiles_onresize();
		});
		ot.photo_tiles_onresize();
	});
	</script>
EOT;

	snippet_photo_tiles_writer($page_ar);

	$buff = '';
	
$buff .= <<<EOT
	<div class='photo_tiles_writer'>
EOT;
		for ($i=0; $i < count($page_ar['meta']['plugin_photo_tiles']['img']); ++$i) {
			$v = $page_ar['meta']['plugin_photo_tiles']['img'][$i];
			$t = '';
			if (is_array($v)) {
				if (!empty($v['txt'])) {
					$t = "<div class='txt'>{$v['txt']}</div>";
					if (!empty($v['url'])) {
						$t = "<div class='txt'><a href='{$ut->link($v['url'])}'>{$v['txt']}</a></div>";
					}
				}
				$v = $v['img'];
			}
			$buff .= "<div class='item onethird-edit-pointer'><div><img src='{$v}' alt='' />$t</div>";
			if (check_rights()) {
$buff .= <<<EOT
				<span class='edit_pointer left bottom' >
					{$ut->icon('edit', "onclick='photo_tiles_writer_edit($i)'")}
				</span>
				<span class='edit_pointer bottom' >
					{$ut->icon('delete', "onclick='photo_tiles_writer_remove($i)'")}
				</span>
EOT;
			}
			$buff .= "</div>";
		}
$buff .= <<<EOT
	</div>
EOT;
	


	return $buff;
}

function photo_line_writer(&$page_ar) 
{
	global $html,$params,$database,$ut;

	$h = $page_ar['meta']['plugin_photo_tiles']['height'];
	$w = $page_ar['meta']['plugin_photo_tiles']['width'];
	$g = $page_ar['meta']['plugin_photo_tiles']['gap'];

$html['css']['photo_tiles_writer'] = <<<EOT
	<style>
	.photo_tiles_writer  {
		position: relative;
		padding:20px 0 0 0;
		width:100%;
		height:$h;
		overflow: hidden;
	}
	.photo_tiles_writer > div {
		width:1000000px;
		cursor:e-resize;
		margin-left:-50px;
	}
	.photo_tiles_writer .item {
		display:inline-block;
		height:$h;
		width:$w;
		padding:0 $g $g 0;
		overflow: hidden;
	}
	.photo_tiles_writer .item > div{
		width: 100%;
		overflow: hidden;
	}
	.photo_tiles_writer .item > div .txt {
		position: absolute;
		top: 0;
		right: $g;
		padding:2px 5px;
		display: inline-block;
		background-color: rgba(255, 255, 255, 0.56);
		font-weight: bold;
		font-size:12px;
    }
	</style>
EOT;

	$buff = '';
	
$buff .= <<<EOT
	<div class='photo_tiles_writer'>
		<div>
EOT;
			for ($i=0; $i < count($page_ar['meta']['plugin_photo_tiles']['img']); ++$i) {
				$v = $page_ar['meta']['plugin_photo_tiles']['img'][$i];
				$v = $page_ar['meta']['plugin_photo_tiles']['img'][$i];
				$t = '';
				if (is_array($v)) {
					if (!empty($v['txt'])) {
						$t = "<div class='txt'>{$v['txt']}</div>";
						if (!empty($v['url'])) {
							$t = "<div class='txt'><a href='{$ut->link($v['url'])}'>{$v['txt']}</a></div>";
						}
					}
					$v = $v['img'];
				}
				$buff .= "<div class='item onethird-edit-pointer'><div><img src='{$v}' alt='' />$t</div>";
				if (check_rights()) {
					$buff .= "<span class='edit_pointer bottom' onclick='photo_tiles_writer_remove($i)'>{$ut->icon('delete')}</span>";
				}
				$buff .= "</div>";
			}
$buff .= <<<EOT
		</div>
	</div>
EOT;

	snippet_photo_tiles_writer($page_ar);

$html['meta']['photo_tiles_writer2'] = <<<EOT
	<script>
	\$(function() {
		ot.photo_tiles = ot.photo_tiles || {};
		ot.photo_tiles.mousedown = function(event) {
			if (event.originalEvent.touches) {
				ot.photo_tiles.pos = event.originalEvent.touches[0].pageX;
			} else {
				ot.photo_tiles.pos = event.pageX;
			}
			ot.photo_tiles.obj = \$('.photo_tiles_writer > div');
			ot.photo_tiles.left = parseInt(ot.photo_tiles.obj.css('margin-left'));
		};
		ot.photo_tiles.mousemove = function(event) {
			if (ot.photo_tiles.pos) {
				var dx;
				if (event.originalEvent.touches) {
					dx = event.originalEvent.touches[0].pageX-ot.photo_tiles.pos;
				} else {
					dx =  event.pageX-ot.photo_tiles.pos;
				}
				if (dx > 70 || dx < -70) {
					dx = ot.photo_tiles.left + dx;
					if (dx < 0) {
						ot.photo_tiles.obj.css('margin-left',dx+'px');
					}
				}
			}
			return false;
		};
		ot.photo_tiles.mouseup = function(event) {
			ot.photo_tiles.pos = 0;
		};
		\$(document).on('touchstart','.photo_tiles_writer > div', ot.photo_tiles.mousedown);
		\$(document).on('mousedown','.photo_tiles_writer > div', ot.photo_tiles.mousedown);
		\$(document).on('touchmove','.photo_tiles_writer > div', ot.photo_tiles.mousemove);
		\$(document).on('mousemove','.photo_tiles_writer > div', ot.photo_tiles.mousemove);
		\$(document).on('touchend','.photo_tiles_writer > div', ot.photo_tiles.mouseup);
		\$(document).on('mouseup','.photo_tiles_writer > div', ot.photo_tiles.mouseup);

	});
	</script>
EOT;
	return $buff;
}

function snippet_photo_tiles_writer(&$page_ar) 
{
	global $html,$params,$database,$ut;
	if (!check_rights('edit')) {
		return;
	}
$html['meta']['photo_tiles_writer'] = <<<EOT
	<script>
		function photo_tiles_writer_remove(a) {
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=photo_tiles_writer_remove&id="+a
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						location.reload(true);
					}
				}
			});
		}
		function photo_tiles_writer_edit(a) {
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=photo_tiles_writer_edit&id="+a
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						\$('#photo_tiles_writer_edit').remove();
						\$('body').append("<div id='photo_tiles_writer_edit' class='onethird-dialog' >"+data['html']+"</div>");
						ot.open_dialog(\$("#photo_tiles_writer_edit"));
					}
				}
			});
		}
		function photo_tiles_writer_save(a) {
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=photo_tiles_writer_save&data="+encodeURIComponent(\$('#photo_tiles_writer_edit .p_text').val())+"&url="+encodeURIComponent(\$('#photo_tiles_writer_edit .p_url').val())+"&id="+a
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						location.reload(true);
					}
				}
			});
		}
	</script>
EOT;
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'photo_tiles_writer_edit') {
		$r = array();
		$r['result'] = true;
		$r['id'] = sanitize_num($_POST['id']) ;
		$x = $u = '';
		for ($i=0; $i < count($page_ar['meta']['plugin_photo_tiles']['img']); ++$i) {
			if ($r['id'] == $i) {
				if (!empty($page_ar['meta']['plugin_photo_tiles']['img'][$i])) {
					$y = $page_ar['meta']['plugin_photo_tiles']['img'][$i];
					if (is_array($y) && !empty($y['txt'])) {
						$x =$y['txt'];
						$u =$y['url'];
					}
				}
				break;
			}
		}
$r['html'] = <<<EOT
		<div class='title'>Caption</div>
		<div class='onethird-setting'>
			TEXT <input type='text' value='{$ut->safe_echo($x)}' class='p_text' />
			URL <input type='text' value='{$ut->safe_echo($x)}' class='p_url' />
			<div class='actions '>
				<input type='button' value='Save' class='onethird-button default' onclick='photo_tiles_writer_save({$r['id']})'  />
				<input type='button' value='Close' class='onethird-button ' onclick='ot.close_dialog()'  />
			</div>
		</div>
EOT;
		echo( json_encode($r) );
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'photo_tiles_writer_save') {
		$r = array();
		$r['result'] = false;
		$r['id'] = sanitize_num($_POST['id']) ;
		for ($i=0; $i < count($page_ar['meta']['plugin_photo_tiles']['img']); ++$i) {
			if ($r['id'] == $i) {
				if (!empty($page_ar['meta']['plugin_photo_tiles']['img'][$i])) {
					$img = $page_ar['meta']['plugin_photo_tiles']['img'][$i];
					if (is_array($img)) {
						$img = $img['img'];
					}
					$page_ar['meta']['plugin_photo_tiles']['img'][$i] = array('txt'=>sanitize_str($_POST['data']), 'img'=>$img, 'url'=>sanitize_str($_POST['url']));
					$page_ar['metadata'] = serialize64($page_ar['meta']);
					$r['result'] = mod_data_items($page_ar);
					break;
				}
			}
		}
		echo( json_encode($r) );
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'photo_tiles_writer_remove') {
		$r = array();
		$r['result'] = false;
		$r['id'] = sanitize_num($_POST['id']) ;
		for ($i=0; $i < count($page_ar['meta']['plugin_photo_tiles']['img']); ++$i) {
			if ($r['id'] == $i) {
				unset($page_ar['meta']['plugin_photo_tiles']['img'][$i]);
				$page_ar['meta']['plugin_photo_tiles']['img'] = array_merge($page_ar['meta']['plugin_photo_tiles']['img']);
				break;
			}
		}
		$page_ar['metadata'] = serialize64($page_ar['meta']);
		$r['result'] = mod_data_items($page_ar);
		echo( json_encode($r) );
		exit();
	}

}

?>